const targetAttr = 'data-tab-component-tab-id'

const assingRefs = node => {
  let container = node

  while (container.classList && !container.classList.contains('tabs-component')) {
    container = container.parentNode
  }

  if (container === document) {
    console.warn('The DOM of tab component is mal formed - a container with class ".tabs-component" is missing')
    return false
  }

  const tabs = container.querySelectorAll('.tabs-title li')
  const contents = container.querySelector('.tabs-content-wrapper')
  const filter = Array.prototype.filter

  tabs.forEach(tab => {
    tab.index = tab.getAttribute('data-tab-component-tab-id')
    tab.contents = contents
    tab.siblings = filter.call(tabs, t => t !== tab)
  })

  return true
}

const handleClick = e => {
  const node = e.target.nodeName.toLowerCase() === 'li' ? e.target : e.target.parentNode

  if (!node.hasAttribute(targetAttr)) {
    return
  }

  if (!node.index && !assingRefs(node)) {
    return
  }

  const finalPosition = node.contents.offsetWidth * node.index

  node.siblings.forEach(n => n.classList.remove('active'))

  if (!node.classList.contains('active')) {
    node.classList.add('active')
  }

  node.contents.scrollLeft = finalPosition
}

window.addEventListener('click', handleClick)

export default { handleClick }
