const loadContent = function (hash, target, callback) {
  if (!target.touched) {
    target.defaultHTML = target.innerHTML
  }

  if (hash === '') {
    target.innerHTML = target.defaultHTML
    return
  }

  const url = `/${hash.replace('#', '')}.html`

  const request = new global.XMLHttpRequest()
  request.open('GET', url, true)
  request.onreadystatechange = () => {
    if (request.readyState !== 4 || request.status !== 200) return
    target.innerHTML = request.responseText
    target.touched = true

    callback()
  }

  request.send()
}

const hashNavigation = (container, callback = () => {}) => {
  global.addEventListener('hashchange', () => {
    loadContent(global.location.hash, container, callback)
  }, false)

  if (global.location.hash !== '') {
    loadContent(global.location.hash, container, callback)
  }
}

export default hashNavigation
